package com.altimetrik.articles.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Collections;
import java.util.List;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import com.altimetrik.articles.controllers.ArticleController;
import com.altimetrik.articles.entity.Article;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
@Slf4j
@Component
public class ArticlesUtil {

	   private static final Logger log = LoggerFactory.getLogger(ArticleController.class);

	@Value("${article.fileName}")
	private String configFileName;
	public static List<Article> fullList;
    public  int count=4;
	@PostConstruct
	public void init() {
		try {
			ClassLoader classLoader = new ArticlesUtil().getClass().getClassLoader();
			InputStream io = classLoader.getResourceAsStream(configFileName);
			fullList = new ObjectMapper().readValue(io, new TypeReference<List<Article>>() {
			});

			fullList.forEach(a -> System.out.println(a.toString()));
			log.info("Validator json loaded successfully");
		}
		catch (JsonParseException e) {
			log.info("Error while parsing the validator json : " + e);
		}
		catch (JsonMappingException e) {
			log.info("Error while mapping the validator json : " + e);
		}
		catch (IOException e) {
			log.info("Error while reading the validator json : " + e);
		}
	}

	public List<Article> call() {
		
		Collections.sort(fullList);
		return fullList;
	}

	public Article call(int id) {
		for (Article article : fullList) {
			if (article.getId() == id) {
				return article;
			}
		}
		return null;

	}

	public Article create(Article article) {
	   
	    article.setId(count);
		fullList.add(article);
		count++;
		// this.addToFile();
		return article;
	}

	/*
	 * private void addToFile() { try { URL url = new
	 * ArticlesUtil().getClass().getClassLoader().getResource(configFileName);
	 * FileWriter f = new FileWriter(url.toURI().getPath()); Gson gson = new
	 * Gson();
	 * 
	 * f.write(gson.toJson(fullList)); f.close(); } catch (URISyntaxException e)
	 * { e.printStackTrace(); } catch (IOException e) { e.printStackTrace(); }
	 * 
	 * }
	 */

	public Article update(int id) throws Exception {
		Article obj = this.call(id);
		if (fullList.remove(obj)) {
			Long l = obj.getVote();
			obj.setVote(++l);
			fullList.add(obj);
		}
		else {
			throw new Exception("No data found to update");
		}
		// addToFile();
		return obj;
	}

}
